# Copyright (c) 2004-2006 Bethel University. All rights reserved.
# See also gpl.txt
""" 
The new and improved XML export for Silva content. This will replace
the existing export machinery.
"""
from Products.Silva.silvaxml.xmlexport import theXMLExporter, SilvaBaseProducer

ProductNS = 'http://zope.org/Members/aaltepet/ns/silva_stylesheets'

def initializeXMLExportRegistry():
    from Products.SilvaStylesheets.Stylesheet import Stylesheet
    exporter = theXMLExporter
    exporter.registerNamespace('stylesheet', ProductNS)
    exporter.registerProducer(Stylesheet, StylesheetProducer)

class StylesheetProducer(SilvaBaseProducer):
    def sax(self):
        self.startElementNS(ProductNS,
                            'stylesheet',
                            {'id': self.context.id,
                             'prefix':self.context.get_css_prefix()}
                          )
        self.startElementNS(ProductNS,'stylesets')
        for (setname,set) in self.context._css.items():
            self.startElementNS(ProductNS,
                                'set',
                                {'name':setname})
            for (style,decls) in set.items():
                if decls:
                    self.startElementNS(ProductNS,
                                        'style',
                                      {'id':style})
                    self.handler.characters('\n'.join(decls))
                    self.endElementNS(ProductNS,'style')
            self.endElementNS(ProductNS,'set')
        self.endElementNS(ProductNS,'stylesets')
        self.metadata()
        
        self.endElementNS(ProductNS,'stylesheet')
