#!/usr/bin/python

forms = {
'anchors': {'name': 'Hyperlinks and Anchors',
            'styles': [
    {'name': "a",
     'description': '''''',
     'extra': '''id="a"''',
     'title': '''a'''},
    {'name': "a__link",
     'description': '''''',
     'extra': '''id="a__link"''',
     'title': '''a:link'''},
    {'name': "a__hover",
     'description': '''''',
     'extra': '''id="a__hover"''',
     'title': '''a:hover'''},
    {'name': "a__active",
     'description': '''''',
     'extra': '''id="a__active"''',
     'title': '''a:active'''},
    {'name': "a__visited",
     'description': '''''',
     'extra': '''id="a__visited"''',
     'title': '''a:visited'''},
    ]
            },
'formatting':{ 'name': 'Formatting and Lists',
               'styles': [
    {'name': "zz.margins",
     'description': '''''',
     'extra': '''id="zz.margins"''',
     'title': '''.margins'''},
    {'name': "li",
     'description': '''List item''',
     'extra': '''id="li"''',
     'title': '''li'''},
    {'name': "li..li",
     'description': '''A nested list item''',
     'extra': '''id="li..li"''',
     'title': '''li li'''},
    {'name': "ul",
     'description': '''Unordered lists''',
     'extra': '''id="ul"''',
     'title': '''ul'''},
    {'name': "ol",
     'description': '''Ordered lists''',
     'extra': '''id="ol"''',
     'title': '''ol'''},
    {'name': "ul.custom-toc",
     'description': '''Custom AutoTOCs use this class for their unordered lists.''',
     'extra': '''id="ul.custom-toc"''',
     'title': '''ul.custom-toc'''},
    {'name': "ul.custom-toc..ul.custom-toc",
     'description': '''Nested lists for Custom AutoTOCs.''',
     'extra': '''id="ul.custom-toc..ul.custom-toc"''',
     'title': '''ul.custom-toc ul.custom-toc'''},
    {'name': "ul.custom-toc..li",
     'description': '''Custom AutoTOC Items.''',
     'extra': '''id="ul.custom-toc..li"''',
     'title': '''ul.custom-toc li'''},
    {'name': "ul.custom-toc..li..p",
     'description': '''Custom AutoTOC Item Descriptions.''',
     'extra': '''id="ul.custom-toc..li..p"''',
     'title': '''ul.custom-toc li p'''},
    {'name': "ul.toc-list",
     'description': '''AutoTOC and TOC lists.''',
     'extra': '''id="toc-list"''',
     'title': '''ul.toc-list'''},
    {'name': "a.toc-link",
     'description': '''AutoTOC and TOC list item links.''',
     'extra': '''id="toc-link"''',
     'title': '''ul.toc-link'''},
    {'name': "dt",
     'description': '''For a definition list: definition term.''',
     'extra': '''id="dt"''',
     'title': '''dt'''},
    {'name': "dd",
     'description': '''For a definition list: definition data.''',
     'extra': '''id="dd"''',
     'title': '''dd'''},
    ]
    },
    'forms':{'name':'Forms',
             'styles': [
             {'name': "div.form-message",
             'description': '''The box displaying form messages after initial form submission.''',
             'extra': '''id="div.form-message"''',
             'title': '''div.form-message'''},
             {'name': "div.form-errors",
             'description': '''The box displaying form errors when for is submitted with errors.''',
             'extra': '''id="div.form-errors"''',
             'title': '''div.form-errors'''},
             {'name': "label",
             'description': '''Field labels''',
             'extra': '''id="label"''',
             'title': '''label'''},
             {'name': "label.form-error",
             'description': '''The label of a field containing errors.''',
             'extra': '''id="label.form-error"''',
             'title': '''label.form-error'''},
             {'name': "label.form-required",
             'description': '''The label of a required field.''',
             'extra': '''id="label.form-required"''',
             'title': '''label.form-required'''},
             {'name': "p.field",
             'description': '''Some input fields have paragraphs around them.''',
             'extra': '''id="p.field"''',
             'title': '''p.field'''},
             {'name': "fieldset",
             'description': '''Some fields (like checkbox groups) use fieldsets.''',
             'extra': '''id="fieldset"''',
             'title': '''fieldset'''},
             {'name': "fieldset..legend",
             'description': '''The legend of a fieldset.''',
             'extra': '''id="fieldset..legend"''',
             'title': '''fieldset legend'''},
             {'name': "table.textarea",
             'description': '''Textareas have a table around them.''',
             'extra': '''id="table.textarea"''',
             'title': '''table.textarea'''},
             {'name': "table.textarea..td.label",
             'description': '''The box displaying form messages after initial form submission.''',
             'extra': '''id="table.textarea..td.label"''',
             'title': '''table.textarea td.label'''},
             {'name': "zz.field_nowrap",
             'description': '''Some fields use this to enforce nowrap.''',
             'extra': '''id="zz.field_nowrap"''',
             'title': '''.field_nowrap'''},
             ]
     },
'headings':{'name':'Headings',
            'styles': [
            {'name': "h2",
            'description': '''''',
            'extra': '''id="h2"''',
            'title': '''h2 (title)'''},
            {'name': "h3",
            'description': '''''',
            'extra': '''id="h3"''',
            'title': '''h3 (heading)'''},
            {'name': "h4",
            'description': '''''',
            'extra': '''id="h4"''',
            'title': '''h4 (sub)'''},
            {'name': "h5",
            'description': '''''',
            'extra': '''id="h5"''',
            'title': '''h5 (subsub)'''},
            {'name': "h6",
            'description': '''''',
            'extra': '''id="h6"''',
            'title': '''h6 (paragraph)'''},
            {'name': "h7",
            'description': '''''',
            'extra': '''id="h7"''',
            'title': '''h7 (subparagraph)'''},
            ]},
'paragraphs':{'name':'Paragraph Types',
              'styles': [
              {'name': "p",
              'description': '''Paragraph''',
              'extra': '''id="p"''',
              'title': '''p'''},
              {'name': "p.lead",
              'description': '''Lead paragraph.  Bold by default.''',
              'extra': '''id="p.lead"''',
              'title': '''p.lead'''},
              {'name': "p.annotation",
              'description': '''''',
              'extra': '''id="p.annotation"''',
              'title': '''p.annotation'''},
              {'name': "p.disclaimer",
              'description': '''Some sites have a copyright disclaimer at the bottom of the content area on all pages.  This disclaimer can be modified using this style.''',
              'extra': '''id="p.disclaimer"''',
              'title': '''p.disclaimer'''},
              {'name': "pre",
              'description': '''''',
              'extra': '''id="pre"''',
              'title': '''pre'''},
              {'name': "div.citation",
              'description': '''''',
              'extra': '''id="div.citation"''',
              'title': '''div.citation'''},
              {'name': "div.citation..p",
              'description': '''''',
              'extra': '''id="div.citation..p"''',
              'title': '''div.citation p'''},
              {'name': "div.citation..p.author",
              'description': '''''',
              'extra': '''id="div.citation..p.author"''',
              'title': '''div.citation p.author'''},
              {'name': "div.citation..p.source",
              'description': '''''',
              'extra': '''id="div.citation..p.source"''',
              'title': '''div.citation p.source'''},
              ]},
'tables':{'name':'Tables (silvatable, plain)',
          'styles' : [
          {'name': "table.silvatable",
          'description': '''Every table in silva uses 'silvatable' styles.''',
          'extra': '''id="table.silvatable"''',
          'title': '''table.silvatable'''},
          {'name': "table.silvatable..td",
          'description': '''The box displaying form messages after initial form submission.''',
          'extra': '''id="table.silvatable..td"''',
          'title': '''table.silvatable td'''},
          {'name': "table.silvatable..tr",
          'description': '''''',
          'extra': '''id="table.silvatable..tr"''',
          'title': '''table.silvatable tr'''},
          {'name': "table.silvatable..tr.rowheading",
          'description': '''''',
          'extra': '''id="table.silvatable..tr.rowheading"''',
          'title': '''table.silvatable tr.rowheading'''},
          {'name': "table.silvatable..tr.rowheading..td",
          'description': '''''',
          'extra': '''id="table.silvatable..tr.rowheading..td"''',
          'title': '''table.silvatable tr.rowheading td'''},
          {'name': "table.silvatable..tr.even",
          'description': '''Even rows.''',
          'extra': '''id="table.silvatable..tr.even"''',
          'title': '''table.silvatable tr.even'''},
          {'name': "table.silvatable..tr.odd",
          'description': '''Odd rows''',
          'extra': '''id="table.silvatable..tr.odd"''',
          'title': '''table.silvatable tr.odd'''},
          {'name': "table.silvatable..td.custom-row-heading",
          'description': '''''',
          'extra': '''id="table.silvatable..td.custom-row-heading"''',
          'title': '''table.silvatable td.custom-row-heading'''},
          {'name': "table.silvatable..th",
          'description': '''Currently only used to style CSV Source headings.''',
          'extra': '''id="table.silvatable..th"''',
          'title': '''table.silvatable th'''},
          {'name': "table.plain",
          'description': '''A table without markup''',
          'extra': '''id="table.plain"''',
          'title': '''table.plain'''},
          {'name': "table.plain..td",
          'description': '''''',
          'extra': '''id="table.plain..td"''',
          'title': '''table.plain td'''},
          {'name': "table.plain..tr.rowheading",
          'description': '''''',
          'extra': '''id="table.plain..tr.rowheading"''',
          'title': '''table.plain tr.rowheading'''},
          {'name': "table.plain..tr.rowheading..td",
          'description': '''''',
          'extra': '''id="table.plain..tr.rowheading..td"''',
          'title': '''table.plain tr.rowheading td'''},
          ]},
'tables2':{'name':'Tables (list, grid, datagrid)',
           'styles': [
           {'name': "table.list",
           'description': '''Listing table''',
           'extra': '''id="table.list"''',
           'title': '''table.list'''},
           {'name': "table.list..td",
           'description': '''''',
           'extra': '''id="table.list..td"''',
           'title': '''table.list td'''},
           {'name': "table.list..tr.rowheading",
           'description': '''''',
           'extra': '''id="table.list..tr.rowheading"''',
           'title': '''table.list tr.rowheading'''},
           {'name': "table.list..tr.rowheading..td",
           'description': '''''',
           'extra': '''id="table.list..tr.rowheading..td"''',
           'title': '''table.list tr.rowheading td'''},
           {'name': "table.grid",
           'description': '''''',
           'extra': '''id="table.grid"''',
           'title': '''table.grid'''},
           {'name': "table.grid..td",
           'description': '''''',
           'extra': '''id="table.grid..td"''',
           'title': '''table.grid td'''},
           {'name': "table.grid..tr.rowheading",
           'description': '''''',
           'extra': '''id="table.grid..tr.rowheading"''',
           'title': '''table.grid tr.rowheading'''},
           {'name': "table.grid..tr.rowheading..td",
           'description': '''''',
           'extra': '''id="table.grid..tr.rowheading..td"''',
           'title': '''table.grid tr.rowheading td'''},
           {'name': "table.datagrid",
           'description': '''''',
           'extra': '''id="table.datagrid"''',
           'title': '''table.datagrid'''},
           {'name': "table.datagrid..td",
           'description': '''''',
           'extra': '''id="table.datagrid..td"''',
           'title': '''table.datagrid td'''},
           {'name': "table.datagrid..tr.rowheading",
           'description': '''''',
           'extra': '''id="table.datagrid..tr.rowheading"''',
           'title': '''table.datagrid tr.rowheading'''},
           {'name': "table.datagrid..tr.rowheading..td",
           'description': '''''',
           'extra': '''id="table.datagrid..tr.rowheading..td"''',
           'title': '''table.datagrid tr.rowheading td'''},
           ]},
'text':{'name':'Text',
        'styles': [
        {'name': "strong",
        'description': '''Bold text''',
        'extra': '''id="strong"''',
        'title': '''strong'''},
        {'name': "sub",
        'description': '''Subscript text''',
        'extra': '''id="sub"''',
        'title': '''sub'''},
        {'name': "sup",
        'description': '''Superscript text''',
        'extra': '''id="sup"''',
        'title': '''sup'''},
        {'name': "em",
        'description': '''Italicized text''',
        'extra': '''id="em"''',
        'title': '''em'''},
        {'name': "u",
        'description': '''Underlined text''',
        'extra': '''id="u"''',
        'title': '''u'''},
        {'name': "acronym",
        'description': '''An acronym contains information about what the acronym means, e.g. ITS is Information Technology Services.''',
        'extra': '''id="acronym"''',
        'title': '''acronym'''},
        {'name': "abbr",
        'description': '''An abbreviation contains information about what the abbreviation means.''',
        'extra': '''id="abbr"''',
        'title': '''abbr'''},
        ]},
'random-cs': { 'name': 'Silva Random Content Source',
               'styles': [
        {'name': "div.random-cs",
     'description': '''The container for Random Content Sources''',
     'extra': '''id="div.random-cs"''',
     'title': '''div.random-cs'''},
        {'name': "div.random-cs..h3",
     'description': '''The title of the Random Content Source''',
     'extra': '''id="div.random-cs..h3"''',
     'title': '''div.random-cs h3'''},
        {'name': "div.random-content",
     'description': '''The div containing the random content.''',
     'extra': '''id="div.random-content"''',
     'title': '''div.random-content'''},
        {'name': "div.random-content..h4.random-content-title",
     'description': '''The title of the random content item.''',
     'extra': '''id="div.random-content..h4"''',
     'title': '''div.random-content h4'''},
        {'name': "div.random-content..p.random-content-desc",
     'description': '''The silva-extra:description of the random content item.''',
     'extra': '''id="div.random-content..p.random-content-desc"''',
     'title': '''div.random-content p.random-content-desc'''},
        {'name': "div.random-cs..div.random-image",
     'description': '''The div containing a random image.''',
     'extra': '''id="div.random-cs..div.random-image"''',
     'title': '''div.random-cs div.random-doc'''},
        {'name': "div.random-cs..div.random-doc",
     'description': '''The div containing a random document.''',
     'extra': '''id="div.random-cs..div.random-doc"''',
     'title': '''div.random-cs div.random-doc'''},
        ]},
'gallery':{'name':'Silva UCL Gallery',
           'styles': [
    {'name':"p.gallery-description",
    'description':'''If the Gallery's silva-extra description metadata is set, it displayed in a paragraph above the images.''',
    'extra': '''id="p.gallery-description" ''',
    'title': '''p.gallery-description'''},
    {'name': "zz.ucl-image-box",
     'description': '''The ucl-image-box surrounds an image and it's title and description.  You can use this to, for example, change the default width of the image boxes.''',
     'extra': '''id="zz.ucl-image-box"''',
     'title': '''.ucl-image-box'''},
    {'name':"p.ucl-image-date",
    'description':'''Paragraph containing an individual image's creation date.''',
    'extra': '''id="p.ucl-image-date" ''',
    'title': '''p.ucl-image-date'''},
    {'name':"zz.ucl-image-title",
    'description':'''The div containing an individual image's title.''',
    'extra': '''id="zz.ucl-image-title" ''',
    'title': '''.ucl-image-title'''},
    {'name':"p.ucl-image-desc",
    'description':'''Paragraph containing an individual image's description.''',
    'extra': '''id="p.ucl-image-desc" ''',
    'title': '''p.ucl-image-desc'''},
     ]
     }
    }

preamble = '''<?xml version="1.0"?>

<form>
  <title></title>
  <row_length>4</row_length>
  <name>%s</name>
  <action></action>
  <method>POST</method>
  <enctype></enctype>
  <encoding>UTF-8</encoding>
  <stored_encoding>ISO-8859-1</stored_encoding>
  <unicode_mode>false</unicode_mode>
  <i18n_domain></i18n_domain>
  <groups>
    <group>
      <title>Default</title>
      <fields>
'''
postamble = '''      </fields>
    </group>
  </groups>
</form>
'''

field = '''      <field><id>%s</id> <type>LinesField</type>
        <values>
          <alternate_name></alternate_name>
          <css_class></css_class>
          <default type="list">[]</default>
          <description>%s</description>
          <enabled type="int">1</enabled>
          <external_validator></external_validator>
          <extra>%s</extra>
          <height type="int">5</height>
          <hidden type="int">0</hidden>
          <max_length></max_length>
          <max_linelength></max_linelength>
          <max_lines></max_lines>
          <required type="int">0</required>
          <title>%s</title>
          <unicode type="int">0</unicode>
          <view_separator>&lt;br /&gt;
</view_separator>
          <whitespace_preserve type="int">0</whitespace_preserve>
          <width type="int">40</width>
        </values>
        <tales>
         <default>python:request.model.get_style(field.aq_parent.id,field.id)</default>
        </tales>
        <messages>
          <message name="external_validator_failed">The input failed the external validator.</message>
          <message name="required_not_found">Input is required but no input given.</message>
          <message name="too_many_lines">You entered too many lines.</message>
          <message name="line_too_long">A line was too long.</message>
          <message name="too_long">You entered too many characters.</message>
        </messages>
      </field>
'''

for key in forms.keys():
  if not forms[key]['styles']:
    continue

  file =  open(key + '.form','w')
  file.write(preamble%(forms[key]['name']))
  styles = forms[key]['styles']
  for s in styles:
    file.write(field%(s['name'],s['description'],s['extra'],s['title']))
  file.write(postamble)
  file.close()
  

